﻿Option Explicit On

Public Class Form1
    Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, lParam As VariantType) As Integer
    Private Declare Auto Function FindWindow Lib "user32" (ByVal lpClassName As String, ByVal lpWindowName As String) As Integer
    Private Declare Auto Function FindWindowEx Lib "user32" (ByVal hwndParent As Integer, ByVal hwndChildAfter As Integer, ByVal lpszClass As String, ByVal lpszWindow As String) As Integer
    Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Integer) As Integer

    Private Const LVM_GETTITEMCOUNT& = (&H1000 + 4)
    Private Const LVM_SETITEMPOSITION& = (&H1000 + 15)
    Private Const LVM_ARRANGE = (&H1000 + 22)
    Private Const LVM_GETITEMPOSITION& = (&H1000 + 16)
    Private Const PI = 3.14159

    Private Structure POINTAPI
        Dim x As Integer
        Dim y As Integer
    End Structure

    Private speed
    Private myRand(1000) As Double
    Private m_lCount As Integer
    Private clickable As Boolean
    Private direction
    Private number, myNumber
    Private num1 As Integer
    Private num2 As Integer
    Private m_udtPoint() As POINTAPI
    Private k As Integer

    Private Function GetSysLV() As Integer
        Dim h As Integer
        h = FindWindow("Progman", vbNullString)
        h = FindWindowEx(h, 0, "SHELLDLL_defVIEW", vbNullString)
        GetSysLV = FindWindowEx(h, 0, "SysListView32", vbNullString)
    End Function

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Me.Location = New Point(-1000, 0)
        k = GetSysLV()
        m_lCount = SendMessage(k, LVM_GETTITEMCOUNT, 0, 0&)

        Randomize()
        speed = 0.06667
        Dim i, h
        h = GetSysLV()
        For i = 0 To SendMessage(h, LVM_GETTITEMCOUNT, 0, 0&)
            myRand(i) = Rnd() * 3 + 1.5
        Next i
        number = 0
        clickable = True
        direction = 0
        Timer1.Enabled = True
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As System.EventArgs) Handles Timer1.Tick
        'Application.DoEvents()
        
        Dim i As Integer, num3, num4
        For i = 0 To m_lCount - 1
            myNumber = (i + number) * 2 * PI / m_lCount
            If direction = 0 Then 'ellipse
                num1 = Math.Cos(myNumber) * Screen.PrimaryScreen.WorkingArea.Width * 3 / 8 + Screen.PrimaryScreen.WorkingArea.Width / 2 - 30
                num2 = Math.Sin(myNumber) * Screen.PrimaryScreen.WorkingArea.Height * 3 / 8 + Screen.PrimaryScreen.WorkingArea.Height / 2 - 50

            ElseIf direction = 1 Then 'four leaf clover
                num3 = Math.Sin(2 * myNumber) * 400             'radius
                num4 = myNumber    'theta
                num1 = num3 * Math.Cos(num4) + Screen.PrimaryScreen.WorkingArea.Width / 2 - 30
                num2 = num3 * Math.Sin(num4) + Screen.PrimaryScreen.WorkingArea.Height / 2 - 50
            ElseIf direction = 2 Then 'sine wave
                num1 = i / m_lCount * Screen.PrimaryScreen.WorkingArea.Width / 1 + 20
                num2 = Math.Sin(myNumber) * Screen.PrimaryScreen.WorkingArea.Height / 3 + Screen.PrimaryScreen.WorkingArea.Height / 2 - 40
            ElseIf direction = 3 Then 'three leaf clover
                num3 = Math.Sin(3 * myNumber / 2) * Screen.PrimaryScreen.WorkingArea.Height / 2           'radius
                num4 = myNumber / 2  'theta
                num1 = num3 * Math.Cos(num4) + Screen.PrimaryScreen.WorkingArea.Width / 2 - 30
                num2 = num3 * Math.Sin(num4) + Screen.PrimaryScreen.WorkingArea.Height / 2 + 20
            ElseIf direction = 4 Then 'happy bounce
                num1 = i / m_lCount * Screen.PrimaryScreen.WorkingArea.Width / 1 + 20
                num2 = -1 * Math.Abs(Math.Sin(myNumber * m_lCount / myRand(i))) * Screen.PrimaryScreen.WorkingArea.Height / 2 + Screen.PrimaryScreen.WorkingArea.Height / 1.33 - 40
            ElseIf direction = 5 Then 'infinity sign
                num1 = Math.Sin(myNumber) * Screen.PrimaryScreen.WorkingArea.Width / 3 + Screen.PrimaryScreen.WorkingArea.Width / 2
                num2 = Math.Sin(2 * myNumber) * Screen.PrimaryScreen.WorkingArea.Height / 3 + Screen.PrimaryScreen.WorkingArea.Height / 2 - 50
            ElseIf direction = 6 Then 'follow the leader
                num1 = Math.Cos(myNumber / 3) * Screen.PrimaryScreen.WorkingArea.Width / 3 + Screen.PrimaryScreen.WorkingArea.Width / 2 + 20
                num2 = Math.Sin(myNumber) * Screen.PrimaryScreen.WorkingArea.Height / 3 + Screen.PrimaryScreen.WorkingArea.Height / 2 - 50
            End If
            SendMessage(k, LVM_SETITEMPOSITION, i, CLng(num1 + num2 * &H10000))
        Next
        number = number + speed
        If GetAsyncKeyState(1) = 0 Then
            clickable = True
            If number > 1000000 Then number = 0
        Else
            If clickable = True Then
                direction = direction + 1
                If direction = 7 Then direction = 0
            End If
            clickable = False
        End If
    End Sub
End Class
